# Properties in the catalog:
# name: string
# city: string
# venue: string
# date: timestamp
# genres: set
# price: double
# 
# Example item:
# name: "New York Philharmonic: Rachmaninoff",
# city: "New York",
# venue: "Lincoln Center",
# date:  "2017-12-10",
# genre: ["classical music"],
# price: 94.0

from recombee_api_client.api_client import RecombeeClient
from recombee_api_client.api_requests import *
import json

client = RecombeeClient('events-example', 'PbBaEVxx8ZOj0x3BhGtqfHyi8qQ8rm8rE1JBnSPoCnHwetzO3gjHer96YVAIa14G')

recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3, cascade_create=True))
print(recommended)
print('--------------------------------------')
recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3, return_properties=True))
print(json.dumps(recommended, indent=4))
print('--------------------------------------')
print("'city' == \"New York\"")
recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3,
                                                return_properties=True,
                                                filter="'city' == \"New York\""))
print(json.dumps(recommended, indent=4))
print('--------------------------------------')
print("'city' == \"New York\" AND 'date' >= now()")
recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3,
                                                return_properties=True,
                                                filter="'city' == \"New York\" AND 'date' >= now()"))
print(json.dumps(recommended, indent=4))
print('--------------------------------------')
print("'city' == \"New York\" AND 'date' >= now() AND \"ballet\" in 'genres'")
recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3,
                                                return_properties=True,
                                                filter="'city' == \"New York\" AND 'date' >= now() AND \"ballet\" in 'genres'"))
print(json.dumps(recommended, indent=4))

print('--------------------------------------')
print("'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres'")
recommended = client.send(RecommendItemsToItem('nyphilharmonic181210', 'user-27', 3,
                                                return_properties=True,
                                                filter="'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres'"))
print(json.dumps(recommended, indent=4))

print('--------------------------------------')
print("'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres' for item laphilharmonic190525")
recommended = client.send(RecommendItemsToItem('laphilharmonic190525', 'user-27', 3,
                                                return_properties=True,
                                                filter="'city' == context_item[\"city\"] AND 'date' >= now() AND \"ballet\" in 'genres'"))

print(json.dumps(recommended, indent=4))
